#!/bin/sh

BASE_DIR="$(cd "$(dirname "$0")" && pwd)"
cd $BASE_DIR

PLUGIN_NAME=siteprobuilder
PLUGIN_PATH=/usr/local/directadmin/plugins/$PLUGIN_NAME
TMP_PATH=$PLUGIN_PATH/user/tmp
PUBLIC_PATH=/var/www/html

cd $PLUGIN_PATH
for dir in user reseller admin include public; do
    if [ -d "$PLUGIN_PATH/$dir" ]; then
        chmod -R 0755 $dir
        chown -R diradmin:diradmin $dir
    fi
done

if [ -d "$TMP_PATH" ]; then
    rm -rf $TMP_PATH
fi

if [ -d "$PUBLIC_PATH/$PLUGIN_NAME" ]; then
	unlink $PUBLIC_PATH/$PLUGIN_NAME
fi
ln -s $PLUGIN_PATH/public $PUBLIC_PATH/$PLUGIN_NAME

php -c $PLUGIN_PATH/user/php.ini $PLUGIN_PATH/include/install.php -- $*
